// Pmd2OgreMesh.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"

#include "common.h"
#include "clsPMDFile.h"
#include "clsVMDFile.h"

#include <cstdio>
#include <iostream>
#include <locale>
#include <clocale>
#include <cstdlib>
#include <wchar.h>
#include <tchar.h>

// PMDf[^p
clsPMDFile *pmd = NULL;
clsVMDFile *vmd = NULL;
// }eAbV
int materialCount = 0;

void createMeshData(char* fileName)
{
    int materialIndexCount = 0;
    char fileName2[256];

    // ꎞf[^
    unsigned int VertexCount, IndexCount;
    float *Vertices;
    unsigned int *Indices;
    float *UData, *VData;
    float *NVector;
    unsigned int *bone1, *bone2, *boneWeight;
	float centerPos[3] = {0, 8, 0};

//	FILE *fp1 = NULL;
//	fopen_s(&fp1, "debug.txt", "w");

	FILE *fp2=NULL;
	sprintf_s(fileName2, 256, "%s.mesh.xml", fileName);
	fopen_s(&fp2, fileName2, "w");//, ccs=UTF-8");//, ccs=UNICODE");

	fprintf_s(fp2, "<mesh>\n");

	// WIgo
	VertexCount = pmd->GetVertexChunkSize();
	fprintf_s(fp2, "\t<sharedgeometry vertexcount=\"%d\">\n", VertexCount);
    fprintf_s(fp2, "\t\t<vertexbuffer positions=\"true\" normals=\"true\" texture_coords=\"1\">\n");
	for (int i=0; i<VertexCount; i++)
	{
		fprintf_s(fp2, "\t\t\t<vertex>\n");
		fprintf_s(fp2, "\t\t\t\t\t\t<position x=\"%f\" y=\"%f\" z=\"%f\"/>\n",
			pmd->GetVertexChunk()[i].x, pmd->GetVertexChunk()[i].y, -pmd->GetVertexChunk()[i].z);
		fprintf_s(fp2, "\t\t\t\t\t\t<normal x=\"%f\" y=\"%f\" z=\"%f\"/>\n",
			pmd->GetVertexChunk()[i].nx, pmd->GetVertexChunk()[i].ny, -pmd->GetVertexChunk()[i].nz);
		fprintf_s(fp2, "\t\t\t\t\t\t<texcoord u=\"%f\" v=\"%f\"/>\n",
			pmd->GetVertexChunk()[i].tx, pmd->GetVertexChunk()[i].ty);
		fprintf_s(fp2, "\t\t\t</vertex>\n");
	}
	fprintf_s(fp2, "\t\t</vertexbuffer>\n");
	fprintf_s(fp2, "\t</sharedgeometry>\n");

	// {[̏o
	fprintf_s(fp2, "\t<boneassignments>\n");
	for (int i=0; i<VertexCount; i++)
	{
		float w1, w2;
		w1 = (float)pmd->GetVertexChunk()[i].bw/100.0f;
		w2 = 1.0f-w1;
		fprintf_s(fp2, "\t\t<vertexboneassignment vertexindex=\"%d\" boneindex=\"%d\" weight=\"%f\"/>\n",
			i, pmd->GetVertexChunk()[i].b1, w1);
		fprintf_s(fp2, "\t\t<vertexboneassignment vertexindex=\"%d\" boneindex=\"%d\" weight=\"%f\"/>\n",
			i, pmd->GetVertexChunk()[i].b2, w2);
	}
	fprintf_s(fp2, "\t</boneassignments>\n");

	// ʏ̏o
	fprintf_s(fp2, "\t<submeshes>\n");
    // }eA̐JԂ
    for (int i=0; i<materialCount; i++)
    {
		// bV̏o
		fprintf_s(fp2, "\t\t<submesh material=\"%s/material%03d\" usesharedvertices=\"true\" use32bitindexes=\"false\" operationtype=\"triangle_list\">\n",
			fileName, i);

        // Index
		IndexCount = pmd->GetMaterialChunk()[i].nEdges;
		printf("indexcount=%d\n", IndexCount);

		// ʏ̏o
		fprintf_s(fp2, "\t\t\t<faces count=\"%d\">\n", IndexCount/3);
		for (int j=0; j<IndexCount/3; j++)
		{
			// ӁFnEnւ̕ϊ
			fprintf_s(fp2, "\t\t\t\t<face v1=\"%d\" v2=\"%d\" v3=\"%d\" />\n",
						pmd->GetIndexChunk()[materialIndexCount+3*j+0],
						pmd->GetIndexChunk()[materialIndexCount+3*j+2],
						pmd->GetIndexChunk()[materialIndexCount+3*j+1]);
		}
		fprintf_s(fp2, "\t\t\t</faces>\n");

		fprintf_s(fp2, "\t\t</submesh>\n");

		materialIndexCount += IndexCount;
    }
	fprintf_s(fp2, "\t</submeshes>\n");

	// submesh̖OƃCfbNX̐ݒ
	fprintf_s(fp2, "\t<submeshnames>\n");
	for (int i=0; i<materialCount; i++)
	{
		fprintf_s(fp2, "\t\t<submeshname name=\"submesh%03d\" index=\"%d\"/>\n",
			i, i);
	}
	fprintf_s(fp2, "\t</submeshnames>\n");

	// posef[^̐ݒ
	fprintf_s(fp2, "\t<poses>\n");
	for (int i=0; i<pmd->GetMorpChunkSize(); i++)
	{
		int mIndex = 0, mOldIndex = -1, vertexNum;
		int vertexOffset = 0;
//		printf_s("name=%s\n", pmd->GetMorpChunk()[i].name);
		if (i == 0)
		{
			fprintf_s(fp2, "\t\t<pose target=\"mesh\" index=\"0\" name=\"base\">\n");
			for (int j=0; j<pmd->GetMorpChunk()[i].vnum; j++)
			{
				fprintf_s(fp2, "\t\t\t<poseoffset index=\"%d\" x=\"0\" y=\"0\" z=\"0\" />\n",
					pmd->GetMorpChunk()[i].mv[j].no);
			}
			
			fprintf_s(fp2, "\t\t</pose>\n");
		}
		else
		{
			fprintf_s(fp2, "\t\t<pose target=\"mesh\" name=\"pose%03d\">\n", i);
			for (int j=0; j<pmd->GetMorpChunk()[i].vnum; j++)
			{
				int baseIndex = pmd->GetMorpChunk()[i].mv[j].no;
				vertexNum = pmd->GetMorpChunk()[0].mv[baseIndex].no;

				fprintf_s(fp2, "\t\t\t<poseoffset index=\"%d\" x=\"%f\" y=\"%f\" z=\"%f\" />\n",
					vertexNum, pmd->GetMorpChunk()[i].mv[j].vec[0], 
					pmd->GetMorpChunk()[i].mv[j].vec[1], 
					-pmd->GetMorpChunk()[i].mv[j].vec[2]);
			}
			fprintf_s(fp2, "\t\t</pose>\n");
		}
	}
	fprintf_s(fp2, "\t</poses>\n");

	// Aj[V̐ݒ
	fprintf_s(fp2, "\t<animations>\n");
	for (int i=0; i<pmd->GetMorpChunkSize(); i++)
	{
		fprintf_s(fp2, "\t\t<animation name=\"anim%03d\" length=\"1.000000\">\n", i);
		fprintf_s(fp2, "\t\t\t<tracks>\n");
		fprintf_s(fp2, "\t\t\t\t<track target=\"mesh\" type=\"pose\">\n");
		fprintf_s(fp2, "\t\t\t\t\t<keyframes>\n");
		fprintf_s(fp2, "\t\t\t\t\t\t<keyframe time=\"0.000000\">\n");
		fprintf_s(fp2, "\t\t\t\t\t\t\t<poseref poseindex=\"%d\" influence=\"0.0\" />\n", i);
		fprintf_s(fp2, "\t\t\t\t\t\t</keyframe>\n");
		fprintf_s(fp2, "\t\t\t\t\t\t<keyframe time=\"1.000000\">\n");
		fprintf_s(fp2, "\t\t\t\t\t\t\t<poseref poseindex=\"%d\" influence=\"1.0\" />\n", i);
		fprintf_s(fp2, "\t\t\t\t\t\t</keyframe>\n");
		fprintf_s(fp2, "\t\t\t\t\t</keyframes>\n");
		fprintf_s(fp2, "\t\t\t\t</track>\n");
		fprintf_s(fp2, "\t\t\t</tracks>\n");
		fprintf_s(fp2, "\t\t</animation>\n");
	}
	fprintf_s(fp2, "\t</animations>\n");

	// XPg̐ݒ
	fprintf_s(fp2, "\t<skeletonlink name=\"%s.skeleton\"/>\n", fileName);

	fprintf_s(fp2, "</mesh>\n");

	fclose(fp2);
//	fclose(fp1);
}

void createMaterialData(char* fileName)
{
    int materialIndexCount = 0;
    char str[256], fileName1[256];

	FILE *fp1=NULL;
	sprintf_s(fileName1, 256, "%s.material", fileName);
	fopen_s(&fp1, fileName1, "w");//, ccs=UTF-8");//, ccs=UNICODE");

    // }eA̐JԂ
    for (int i=0; i<materialCount; i++)
    {
		// Materialt@C̏o
		fprintf_s(fp1, "\n");
		fprintf_s(fp1, "material %s/material%03d\n", fileName, i);
		fprintf_s(fp1, "{\n");
		fprintf_s(fp1, "\ttechnique\n");
		fprintf_s(fp1, "\t{\n");
		fprintf_s(fp1, "\t\tpass\n");
		fprintf_s(fp1, "\t\t{\n");
		fprintf_s(fp1, "\t\t\tambient %f %f %f\n", pmd->GetMaterialChunk()[i].ambient.r,
			pmd->GetMaterialChunk()[i].ambient.g, pmd->GetMaterialChunk()[i].ambient.b);
		fprintf_s(fp1, "\t\t\tdiffuse %f %f %f %f\n", pmd->GetMaterialChunk()[i].diffuse.r,
			pmd->GetMaterialChunk()[i].diffuse.g, pmd->GetMaterialChunk()[i].diffuse.b,
			pmd->GetMaterialChunk()[i].diffuse.a);
		fprintf_s(fp1, "\t\t\tspecular %f %f %f %f\n", pmd->GetMaterialChunk()[i].specular.r,
			pmd->GetMaterialChunk()[i].specular.g, pmd->GetMaterialChunk()[i].specular.b,
			pmd->GetMaterialChunk()[i].shininess);

        // PMDt@C̃}eAeNX`擾
        sprintf_s(str, 256, "%s", pmd->GetMaterialChunk()[i].textureFileName);
        // eNX`t@Cw肳Ăꍇ
        if (strcmp(str, "") != 0)
        {
            // eNX`t@Cݒ
			fprintf_s(fp1, "\n");
			fprintf_s(fp1, "\t\t\ttexture_unit\n");
			fprintf_s(fp1, "\t\t\t{\n");
			fprintf_s(fp1, "\t\t\t\ttexture %s\n", str);
			fprintf_s(fp1, "\t\t\t}\n");
        }

		fprintf_s(fp1, "\t\t}\n");
		fprintf_s(fp1, "\t}\n");
		fprintf_s(fp1, "}\n");
	}

	fclose(fp1);
}

void createJointData(char* fileName)
{
	char outputFileName[256];
	sprintf_s(outputFileName, 256, "%s.skeleton.xml", fileName);
	FILE *fp;
	fopen_s(&fp, outputFileName, "w");//, ccs=UNICODE");
    
	// wb_̏o
	fprintf_s(fp, "<skeleton>\n");

	// XPg̏o
	fprintf_s(fp, "\t<bones>\n");
    for (int i=0; i<pmd->GetBoneChunkSize(); i++)
    {
		// {[IDƖO
#if 0
		fprintf_s(fp, "\t\t<bone id=\"%d\" name=\"%s\">\n", i, pmd->GetBoneChunk()[i].name);
#else
		fprintf_s(fp, "\t\t<bone id=\"%d\" name=\"bone%03d\">\n", i, i);
#endif

		// {[ʒui΍WHj
		fprintf_s(fp, "\t\t\t<position x=\"%f\" y=\"%f\" z=\"%f\" />\n",
			pmd->GetBoneChunk()[i].pos[0], pmd->GetBoneChunk()[i].pos[1], -pmd->GetBoneChunk()[i].pos[2]);
		
		// {[̎pipxƉ]jPMDł͉]Ȃ
//		fprintf_s(fp, "\t\t\t<rotation angle=\"3.141593\">\n");
		fprintf_s(fp, "\t\t\t<rotation angle=\"0.000000\">\n");
		fprintf_s(fp, "\t\t\t\t<axis x=\"0.000000\" y=\"0.000000\" z=\"1.000000\" />\n");
		fprintf_s(fp, "\t\t\t</rotation>\n");
		// {[^O
		fprintf_s(fp, "\t\t</bone>\n");
	}
	// XPg^O
	fprintf_s(fp, "\t</bones>\n");

	// XPg\̏o
	fprintf_s(fp, "\t<bonehierarchy>\n");
    for (int i=0; i<pmd->GetBoneChunkSize(); i++)
    {
        // em[h邩ǂ
        if (pmd->GetBoneChunk()[i].parent == (WORD)-1)
        {
			// Ȃꍇ͉Ȃ
        }
        else
        {
            // eꍇ͎擾Ēǉ
#if 0
			fprintf_s(fp, "\t\t<boneparent bone=\"%s\" parent=\"%s\" />\n", 
				pmd->GetBoneChunk()[i].name, pmd->GetBoneChunk()[pmd->GetBoneChunk()[i].parent].name);
#else
			fprintf_s(fp, "\t\t<boneparent bone=\"bone%03d\" parent=\"bone%03d\" />\n", 
				i, pmd->GetBoneChunk()[i].parent);
#endif
        }
	}
	// XPg\^O
	fprintf_s(fp, "\t</bonehierarchy>\n");

	// XPg^O
	fprintf_s(fp, "</skeleton>\n");

	fclose(fp);
}

bool createOgreXML(char *fileName)
{
    // t@C\
    char filename[256], path[256];
    ::GetCurrentDirectoryA(MAX_PATH, path);
	sprintf_s(filename, sizeof(filename), "%s.pmd", fileName);
    printf("filename=%s\n", filename);

    int i, ret;

    if (pmd != NULL)
    {
        return false;
    }

    // PMDf[^̓ǂݍ
    pmd = new clsPMDFile;
	if ( !pmd->Open(filename))
    {
        printf("Can't open PMD file! %s\n",
            filename);
        getchar();
        return false;
    }

	printf("Version=%f\n", pmd->GetVersion());
	printf("English?=%d\n", (int)pmd->m_emodel_name.english_name_compatibility);
	if (pmd->IsEnglishNameCompatibility())
	{
		printf("ename=%s\n", pmd->m_emodel_name.model_name_eg);
		printf("ecomment=%s\n", pmd->m_emodel_name.comment_eg);

		for (i=0; i<pmd->GetEBoneNameChunkSize(); i++)
		{
			printf("EBoneName[%d]=%s\n", i, pmd->GetEBoneNameChunk()[i].bone_name_eg);
		}

		for (i=0; i<pmd->GetESkinNameChunkSize(); i++)
		{
			printf("ESkinName[%d]=%s\n", i, pmd->GetESkinNameChunk()[i].skin_name_eg);
		}

		for (i=0; i<pmd->GetEDispNameChunkSize(); i++)
		{
			printf("EDispName[%d]=%s\n", i, pmd->GetEDispNameChunk()[i].disp_name_eg);
		}

		for (i=0; i<pmd->GetToonTexNameChunkSize(); i++)
		{
			printf("Toon Texture Name[%d]=%s\n", i, pmd->GetToonTexNameChunk()[i].toon_file_name);
		}

		for (i=0; i<pmd->GetRigidBodyChunkSize(); i++)
		{
			printf("Rigid Body Name[%d]=%s\n", i, pmd->GetRigidBodyChunk()[i].rigidbody_name);
		}

		for (i=0; i<pmd->GetJointChunkSize(); i++)
		{
			printf("Joint Name[%d]=%s\n", i, pmd->GetJointChunk()[i].joint_name);
		}
	}

    // ܂̓XPgf[^쐬
    printf("Create Joint Data\n");
    createJointData(fileName);

    // ̓}eAf[^쐬
    materialCount = pmd->GetMaterialChunkSize();
    printf("Create Material Data\n");
    createMaterialData(fileName);

	// ŌɃbVf[^쐬
	printf("Create MeshData\n");
	createMeshData(fileName);
	
	return true;
}

int _tmain(int argc, _TCHAR* argv[])
{
    // RĂȂƃt@CEEE
    std::locale::global(std::locale("japanese"));
	std::setlocale(LC_ALL,"japanese");
	std::wcout.imbue(std::locale("japanese"));

	if( argc != 2 )
	{
		fprintf( stderr, "Usage: Pmd2OgreMesh.exe <PMD file name> \n\nPlease remove the extension (.pmd) from the file name.\n");
		getchar();
		exit(0);
	}

	bool ret = createOgreXML(argv[1]);
	if (ret)
	{
		printf("Success\n");
	}
	else
	{
		printf("Failed\n");
	}

	printf("EnterL[ŏI܂B\n");
	getchar();

	return 0;
}

