#include "stdafx.h"
#include "common.h"
#include "MMD_IO.h"

#include "clsPMDFile.h"

clsPMDFile::clsPMDFile(void)
{
}

clsPMDFile::~clsPMDFile(void)
{
}
BOOL clsPMDFile::Open(const char* name)
{
	BYTE	size_b;
	WORD	size_w;
	DWORD	size_dw;
	size_t	size;
	fstream fs;

    fs.open( name, ios::in | ios::binary,_SH_SECURE );
	if ( fs.bad() || fs.fail() )
    {
        printf("fs.bad() || fs.fail()\n");
		return FALSE;
    }

	fs.read( (char*)&m_header,sizeof(m_header) );

	fs.read( (char*)&size,sizeof(size) );
	SetVertexChunkSize(size);
	if ( size )
		fs.read( (char*)&GetVertexChunk()[0],size*sizeof(PMD_VERTEX_RECORD) );

	fs.read( (char*)&size,sizeof(size) );
	SetIndexChunkSize(size);
	if ( size )
		fs.read( (char*)&GetIndexChunk()[0],size*sizeof(WORD) );

	fs.read( (char*)&size,sizeof(size) );
	SetMaterialChunkSize(size);
	if ( size )
		fs.read( (char*)&GetMaterialChunk()[0],size*sizeof(PMD_MATERIAL_RECORD) );

	fs.read( (char*)&size_w,sizeof(size_w) );
	SetBoneChunkSize( size_w );
	if ( size_w )
		fs.read( (char*)&GetBoneChunk()[0],size_w*sizeof(PMD_BONE_RECORD) );

	fs.read( (char*)&size_w,sizeof(size_w) );
	SetIKChunkSize( size_w );
	for (int i=0;i<size_w;i++){
		GetIKChunk()[i].Read(fs);
	}

	fs.read( (char*)&size_w,sizeof(size_w) );
	SetMorpChunkSize( size_w );
	for (int i=0;i<size_w;i++){
		GetMorpChunk()[i].Read(fs);
	}

	fs.read( (char*)&size_b,sizeof(size_b) );
	SetCtrlChunkSize( size_b );
	if ( size_b )
		fs.read( (char*)&GetCtrlChunk()[0],size_b*sizeof(WORD) );

	fs.read( (char*)&size_b,sizeof(size_b) );
	SetGrpNameChunkSize( size_b );
	if ( size_b )
		fs.read( (char*)&GetGrpNameChunk()[0],size_b*sizeof(PMD_GRP_NAME_RECORD) );

	fs.read( (char*)&size,sizeof(size) );
	SetGrpChunkSize( size );
	if ( size )
		fs.read( (char*)&GetGrpChunk()[0],size*sizeof(PMD_GRP_RECORD) );

	printf("boneNum=%d, morfnum=%d, grpnum=%d\n", 
		GetBoneChunkSize(), GetMorpChunkSize(), GetGrpNameChunkSize());

	// pꖼΉ
	fs.read( (char*)&m_emodel_name, sizeof(PMD_EMODEL_NAME_RECORD) );

	if (m_emodel_name.english_name_compatibility == 0x01)
	{
		printf("english name compatibility = true\n");
	}
	else
	{
		printf("english name compatibility = false\n");
		return TRUE;
	}

	size = GetBoneChunkSize();
	SetEBoneNameChunkSize( size );
	if ( size )
		fs.read( (char*)&GetEBoneNameChunk()[0], size*sizeof(PMD_EBONE_NAME_RECORD) );

	size = GetMorpChunkSize() - 1;
	SetESkinNameChunkSize( size );
	if ( size )
		fs.read( (char*)&GetESkinNameChunk()[0], size*sizeof(PMD_ESKIN_NAME_RECORD) );

	size = GetGrpNameChunkSize();
	SetEDispNameChunkSize( size );
	if ( size )
		fs.read( (char*)&GetEDispNameChunk()[0], size*sizeof(PMD_EDISP_NAME_RECORD) );

	// gD[eNX`Xg
	size = 10;
	SetToonTexNameChunkSize( size );
	if ( size )
		fs.read( (char*)&GetToonTexNameChunk()[0], size*sizeof(PMD_TOONTEX_NAME_RECORD) );

	// Z
	fs.read( (char*)&size_dw,sizeof(size_dw) );
	SetRigidBodyChunkSize( size_dw );
	if ( size_dw )
		fs.read( (char*)&GetRigidBodyChunk()[0],size_dw*sizeof(PMD_RIGIDBODY_RECORD) );

	fs.read( (char*)&size_dw, sizeof(size_dw) );
	SetJointChunkSize( size_dw );
	if ( size_dw )
		fs.read( (char*)&GetJointChunk()[0], size_dw*sizeof(PMD_JOINT_RECORD) );

	return TRUE;
}

BOOL clsPMDFile::Commit(const char* name)
{
	BYTE   size_b;
	WORD   size_w;
	size_t size;
	fstream fs;

	fs.open( name,ios::out | ios::binary,_SH_SECURE );
	if ( fs.bad() || fs.fail() )
		return FALSE;

	fs.write( (char*)&m_header,sizeof(m_header) );

	size = GetVertexChunkSize();
	fs.write( (char*)&size,sizeof(size) );
	if ( size )
		fs.write( (char*)&GetVertexChunk()[0],size*sizeof(PMD_VERTEX_RECORD) );

	size = GetIndexChunkSize();
	fs.write( (char*)&size,sizeof(size) );
	if ( size )
		fs.write( (char*)&GetIndexChunk()[0],size*sizeof(WORD) );

	size=GetMaterialChunkSize();
	fs.write( (char*)&size,sizeof(size) );
	if ( size )
		fs.write( (char*)&GetMaterialChunk()[0],size*sizeof(PMD_MATERIAL_RECORD) );

	size_w = GetBoneChunkSize();
	fs.write( (char*)&size_w,sizeof(size_w) );
	if ( size_w )
		fs.write( (char*)&GetBoneChunk()[0],size_w*sizeof(PMD_BONE_RECORD) );

	size_w = GetIKChunkSize();
	fs.write( (char*)&size_w,sizeof(size_w) );
	for (int i=0;i<size_w;i++){
		GetIKChunk()[i].Write(fs);
	}

	size_w = GetMorpChunkSize();
	fs.write( (char*)&size_w,sizeof(size_w) );
	for (int i=0;i<size_w;i++){
		GetMorpChunk()[i].Write(fs);
	}

	size_b = GetCtrlChunkSize();
	fs.write( (char*)&size_b,sizeof(size_b) );
	if ( size_b )
		fs.write( (char*)&GetCtrlChunk()[0],size_b*sizeof(WORD) );

	size_b = GetGrpNameChunkSize(  );
	fs.write( (char*)&size_b,sizeof(size_b) );
	if ( size_b )
		fs.write( (char*)&GetGrpNameChunk()[0],size_b*sizeof(PMD_GRP_NAME_RECORD) );

	size = GetGrpChunkSize();
	fs.write( (char*)&size,sizeof(size) );
	if ( size )
		fs.write( (char*)&GetGrpChunk()[0],size*sizeof(PMD_GRP_RECORD) );

	return TRUE;
}

float		clsPMDFile::GetVersion()
{
	printf("version = %f\n", m_header.version);
	return m_header.version;
}

void	clsPMDFile::SetVersion(float ver)
{
}

const char* clsPMDFile::GetHeaderString()
{
	return m_header.header2;
}

void	clsPMDFile::SetHeaderString(const char* name)
{
	memcpy_s( (char*)&m_header,sizeof(m_header)-1,name,_TRUNCATE );
}

const char* clsPMDFile::GetActor()
{
	return m_header.model_name;
//	return &m_header.header1[0x7];
}
void	clsPMDFile::SetActor(const char* name )
{
//	strncpy_s( &m_header.header1[0x7],_countof(m_header.header1)-0x7,name,_TRUNCATE );
	strncpy_s( m_header.model_name, 20, name, 20);
}

int		clsPMDFile::GetVertexChunkSize()
{
	return m_vertexs.size();
}
void	clsPMDFile::SetVertexChunkSize(int size)
{
	m_vertexs.resize(size);
}
PMD_VERTEX_CHUNK& clsPMDFile::GetVertexChunk()
{
	return m_vertexs;
}

int		clsPMDFile::GetIndexChunkSize()
{
	return m_indexs.size();
}
void	clsPMDFile::SetIndexChunkSize(int size)
{
	m_indexs.resize(size);
}
PMD_INDEX_CHUNK& clsPMDFile::GetIndexChunk()
{
	return m_indexs;
}

int		clsPMDFile::GetBoneChunkSize()
{
	return m_bones.size();
}
void	clsPMDFile::SetBoneChunkSize(int size)
{
	m_bones.resize( size );
}
vector<PMD_BONE_RECORD>& clsPMDFile::GetBoneChunk()
{
	return m_bones;
}
int		clsPMDFile::GetIKChunkSize()
{
	return m_ikbones.size();
}
void	clsPMDFile::SetIKChunkSize(int size)
{
	m_ikbones.resize(size);
}
PMD_IK_CHUNK& clsPMDFile::GetIKChunk()
{
	return m_ikbones;
}

int		clsPMDFile::GetMaterialChunkSize()
{
	return m_materials.size();
}

void	clsPMDFile::SetMaterialChunkSize(int size)
{
	m_materials.resize( size );
}

PMD_MATERIAL_CHUNK& clsPMDFile::GetMaterialChunk()
{
	return m_materials;
}

int		clsPMDFile::GetMorpChunkSize()
{
	return m_morps.size();
}

void	clsPMDFile::SetMorpChunkSize(int size)
{
	m_morps.resize(size);
}

PMD_MORP_CHUNK& clsPMDFile::GetMorpChunk()
{
	return m_morps;
}
int		clsPMDFile::GetCtrlChunkSize()
{
	return m_ctrls.size();
}
void	clsPMDFile::SetCtrlChunkSize(int size)
{
	m_ctrls.resize(size);
}
vector<WORD>& clsPMDFile::GetCtrlChunk()
{
	return m_ctrls;
}

int		clsPMDFile::GetGrpNameChunkSize()
{
	return m_grp_name.size();
}
void	clsPMDFile::SetGrpNameChunkSize(int size)
{
	m_grp_name.resize(size);
}
PMD_GRP_NAME_CHUNK& clsPMDFile::GetGrpNameChunk()
{
	return m_grp_name;
}

int		clsPMDFile::GetGrpChunkSize()
{
	return m_grp.size();
}
void	clsPMDFile::SetGrpChunkSize(int size)
{
	m_grp.resize(size);
}
PMD_GRP_CHUNK& clsPMDFile::GetGrpChunk()
{
	return m_grp;
}

bool clsPMDFile::IsEnglishNameCompatibility()
{
	if (m_emodel_name.english_name_compatibility == 0x01)
	{
		return true;
	}
	return false;
}

int		clsPMDFile::GetEBoneNameChunkSize()
{
	return m_ebone_name.size();
}

void	clsPMDFile::SetEBoneNameChunkSize(int size)
{
	m_ebone_name.resize(size);
}

PMD_EBONE_NAME_CHUNK& clsPMDFile::GetEBoneNameChunk()
{
	return m_ebone_name;
}

int		clsPMDFile::GetESkinNameChunkSize()
{
	return m_eskin_name.size();
}

void	clsPMDFile::SetESkinNameChunkSize(int size)
{
	m_eskin_name.resize(size);
}

PMD_ESKIN_NAME_CHUNK& clsPMDFile::GetESkinNameChunk()
{
	return m_eskin_name;
}

int		clsPMDFile::GetEDispNameChunkSize()
{
	return m_edisp_name.size();
}

void	clsPMDFile::SetEDispNameChunkSize(int size)
{
	m_edisp_name.resize(size);
}

PMD_EDISP_NAME_CHUNK& clsPMDFile::GetEDispNameChunk()
{
	return m_edisp_name;
}

int		clsPMDFile::GetToonTexNameChunkSize()
{
	return m_toontex_name.size();
}

void	clsPMDFile::SetToonTexNameChunkSize(int size)
{
	m_toontex_name.resize(size);
}

PMD_TOONTEX_NAME_CHUNK& clsPMDFile::GetToonTexNameChunk()
{
	return m_toontex_name;
}

int		clsPMDFile::GetRigidBodyChunkSize()
{
	return m_rigidbody.size();
}

void	clsPMDFile::SetRigidBodyChunkSize(int size)
{
	m_rigidbody.resize(size);
}

PMD_RIGIDBODY_CHUNK& clsPMDFile::GetRigidBodyChunk()
{
	return m_rigidbody;
}

int		clsPMDFile::GetJointChunkSize()
{
	return m_joint.size();
}

void	clsPMDFile::SetJointChunkSize(int size)
{
	m_joint.resize(size);
}

PMD_JOINT_CHUNK& clsPMDFile::GetJointChunk()
{
	return m_joint;
}
