#pragma once

//#include "BoneNode.h"
#pragma warning( disable:4530 )

#pragma pack(1)
	struct PMD_HEADER {
		PMD_HEADER(){
//			memset(header1,0xFD,sizeof(header1));
			memset(header2,0xFD,sizeof(header2));
		}
		char magic[3];
		float version;
		char model_name[20];
//		char header1[0x1b];
		char header2[0x100];
	};
	struct PMD_VERTEX_RECORD {
		float x;	// W
		float y;
		float z;
		float nx;	// @xNg
		float ny;	
		float nz;
		float tx;	// eNX`UV
		float ty;
		WORD  b1;	// {[1
		WORD  b2;	// {[2
		BYTE  bw;	// EFCg
		BYTE  unknown;	// GbW
	};
	struct PMD_INDEX_RECORD {
		WORD  id;	// _ԍ
	};
	struct PMD_MATERIAL_RECORD {	// }eA
		struct { 
			float r;
			float g;
			float b;
			float a;
		} diffuse;
		float shininess;
		struct { 
			float r;
			float g;
			float b;
		} specular, ambient;
		WORD p12;
		DWORD nEdges;
		char textureFileName[20]; 
	};
	struct PMD_BONE_RECORD {
		char  name[20];
		WORD  parent;
		WORD  to;
		BYTE  kind;
		WORD  knum;
		float pos[3];
	};
	struct PMD_IK_RECORD {
		void Read(istream &is) {
			is.read( (char*)&parent,sizeof(parent) );
			is.read( (char*)&to,sizeof(to) );
			is.read( (char*)&num_link,sizeof(num_link) );
			is.read( (char*)&count,sizeof(count) );
			is.read( (char*)&fact,sizeof(fact) );
			link.resize(num_link);
			is.read( (char*)&link[0],num_link*sizeof(WORD) );
		};
		void Write(ostream &os) {
			os.write( (char*)&parent,sizeof(parent) );
			os.write( (char*)&to,sizeof(to) );
			os.write( (char*)&num_link,sizeof(num_link) );
			os.write( (char*)&count,sizeof(count) );
			os.write( (char*)&fact,sizeof(fact) );
			os.write( (char*)&link[0],num_link*sizeof(WORD) );
		};
		WORD  parent;
		WORD  to;
		BYTE  num_link;
		WORD  count;
		float fact;
		vector<WORD>link;
	};
	struct PMD_MORP_VERTEX_RECORD {
		int no;
		float vec[3];
	};

	struct PMD_MORP_RECORD {
		void Read(istream &is) {
			is.read( name,sizeof(name) );
			is.read( (char*)&vnum,sizeof(vnum) );
			is.read( (char*)&grp,sizeof(grp) );
			mv.resize(vnum);
			is.read( (char*)&mv[0],vnum*sizeof(PMD_MORP_VERTEX_RECORD) );
		}
		void Write(ostream &os) {
			os.write( name,sizeof(name) );
			os.write( (char*)&vnum,sizeof(vnum) );
			os.write( (char*)&grp,sizeof(grp) );
			os.write( (char*)&mv[0],vnum*sizeof(PMD_MORP_VERTEX_RECORD) ); 
		}
		char  name[20];
		DWORD vnum;
		BYTE grp;
		vector<PMD_MORP_VERTEX_RECORD>mv;
	};
	
	struct PMD_GRP_NAME_RECORD {
		char name[50];
	};

	struct PMD_GRP_RECORD {
		WORD bone_no;
		BYTE grp;
	};

/*
	struct PMD_MORP_RECORD {
		void Read(istream &is) {
			is.read( (char*)&nnum,sizeof(nnum) );
			mt.resize( nnum );
			for (int i=0;i<nnum;i++){
				mt[i].Read( is );
			}
		};
		void Write(ostream &os) {
			os.write( (char*)&nnum,sizeof(nnum) );
			for (int i=0;i<nnum;i++){
				mt[i].Write( os );
			}
		};
		WORD nnum;
		vector<PMD_MORP_TARGET_RECORD>mt;
	};
*/
	struct PMD_EMODEL_NAME_RECORD {
		BYTE english_name_compatibility; // pΉ(01:pΉ)
		char model_name_eg[20]; // f(p)
		char comment_eg[256]; // Rg(p)
	};
	struct PMD_EBONE_NAME_RECORD {
		// bone_count == 122
		char bone_name_eg[20]; // {[(p)
	};
	struct PMD_ESKIN_NAME_RECORD {
		// skin_count == 16 // base͉po^Ȃ̂15 (total 300Bytes)
		char skin_name_eg[20]; // \(p)
	};
	struct PMD_EDISP_NAME_RECORD {
		// bone_disp_name_count == 7 // Z^[͉po^Ȃ̂7 (total 350Bytes)
		char disp_name_eg[50]; // g(p) // MMDł́u敪v
	};
	struct PMD_TOONTEX_NAME_RECORD {
		// 10Œ (total 1000Bytes)
		char toon_file_name[100]; // gD[eNX`t@C
	};
	struct PMD_RIGIDBODY_RECORD {
		char rigidbody_name[20]; // f[^F // 
		WORD rigidbody_rel_bone_index; // f[^F֘A{[ԍ // 03 00 == 3 // 
		BYTE rigidbody_group_index; // f[^FO[v // 00
		WORD rigidbody_group_target; // f[^FO[vFΏ // 0xFFFFƂ̍ // 38 FE
		BYTE shape_type; // `F^Cv(0:A1:A2:JvZ) // 00 // 
		float shape_w; // `Fa() // CD CC CC 3F // 1.6
		float shape_h; // `F // CD CC CC 3D // 0.1
		float shape_d; // `Fs // CD CC CC 3D // 0.1
		float pos_pos[3]; // ʒuFʒu(x, y, z)
		float pos_rot[3]; // ʒuF](rad(x), rad(y), rad(z))
		float rigidbody_weight; // f[^F // 00 00 80 3F // 1.0
		float rigidbody_pos_dim; // f[^Fړ // 00 00 00 00
		float rigidbody_rot_dim; // f[^F] // 00 00 00 00
		float rigidbody_recoil; // f[^F // 00 00 00 00
		float rigidbody_friction; // f[^FC // 00 00 00 00
		BYTE rigidbody_type; // f[^F^Cv(0:BoneǏ]A1:ZA2:Z(Boneʒu)) // 00 // BoneǏ]
	};
	struct PMD_JOINT_RECORD {
		char joint_name[20]; // f[^F // E1
		DWORD joint_rigidbody_a; // f[^FA
		DWORD joint_rigidbody_b; // f[^FB
		float joint_pos[3]; // f[^Fʒu(x, y, z) // f[^Fʒułݒ
		float joint_rot[3]; // f[^F](rad(x), rad(y), rad(z))
		float constrain_pos_1[3]; // Fړ1(x, y, z)
		float constrain_pos_2[3]; // Fړ2(x, y, z)
		float constrain_rot_1[3]; // F]1(rad(x), rad(y), rad(z))
		float constrain_rot_2[3]; // F]2(rad(x), rad(y), rad(z))
		float spring_pos[3]; // ΂ˁFړ(x, y, z)
		float spring_rot[3]; // ΂ˁF](rad(x), rad(y), rad(z))
	};

#pragma pack(8)

typedef vector<PMD_VERTEX_RECORD>   PMD_VERTEX_CHUNK;
typedef vector<WORD>			    PMD_INDEX_CHUNK;
typedef vector<PMD_MATERIAL_RECORD> PMD_MATERIAL_CHUNK;
typedef vector<PMD_BONE_RECORD>     PMD_BONE_CHUNK;
typedef vector<PMD_IK_RECORD>		PMD_IK_CHUNK;
typedef vector<PMD_MORP_RECORD>     PMD_MORP_CHUNK;
typedef vector<WORD>			    PMD_CTRL_CHUNK;
typedef vector<PMD_GRP_NAME_RECORD>	PMD_GRP_NAME_CHUNK;
typedef vector<PMD_GRP_RECORD>      PMD_GRP_CHUNK;

typedef vector<PMD_EBONE_NAME_RECORD>	PMD_EBONE_NAME_CHUNK;
typedef vector<PMD_ESKIN_NAME_RECORD>	PMD_ESKIN_NAME_CHUNK;
typedef vector<PMD_EDISP_NAME_RECORD>	PMD_EDISP_NAME_CHUNK;
typedef vector<PMD_TOONTEX_NAME_RECORD>	PMD_TOONTEX_NAME_CHUNK;
typedef vector<PMD_RIGIDBODY_RECORD>	PMD_RIGIDBODY_CHUNK;
typedef vector<PMD_JOINT_RECORD>		PMD_JOINT_CHUNK;

class clsPMDFile
{
public:
	clsPMDFile(void);
	~clsPMDFile(void);

	BOOL Open(const char* name);
	BOOL Commit(const char* name);

	float	GetVersion();
	void	SetVersion(float ver);

	const char* GetHeaderString();
	void	SetHeaderString(const char* name);

	const char*	GetActor();
	void	SetActor(const char* name );

	int		GetVertexChunkSize();
	void	SetVertexChunkSize(int size);
	PMD_VERTEX_CHUNK& GetVertexChunk();

	int		GetIndexChunkSize();
	void	SetIndexChunkSize(int size);
	PMD_INDEX_CHUNK& GetIndexChunk();

	int		GetBoneChunkSize();
	void	SetBoneChunkSize(int size);
	PMD_BONE_CHUNK& GetBoneChunk();

	int		GetIKChunkSize();
	void	SetIKChunkSize(int size);
	PMD_IK_CHUNK& GetIKChunk();

	int		GetMaterialChunkSize();
	void	SetMaterialChunkSize(int size);
	PMD_MATERIAL_CHUNK& GetMaterialChunk();

	int		GetMorpChunkSize();
	void	SetMorpChunkSize(int size);
	PMD_MORP_CHUNK& GetMorpChunk();

	int		GetCtrlChunkSize();
	void	SetCtrlChunkSize(int size);
	PMD_CTRL_CHUNK& GetCtrlChunk();

	int		GetGrpNameChunkSize();
	void	SetGrpNameChunkSize(int size);
	PMD_GRP_NAME_CHUNK& GetGrpNameChunk();

	int		GetGrpChunkSize();
	void	SetGrpChunkSize(int size);
	PMD_GRP_CHUNK& GetGrpChunk();

	bool IsEnglishNameCompatibility();

	int		GetEBoneNameChunkSize();
	void	SetEBoneNameChunkSize(int size);
	PMD_EBONE_NAME_CHUNK& GetEBoneNameChunk();

	int		GetESkinNameChunkSize();
	void	SetESkinNameChunkSize(int size);
	PMD_ESKIN_NAME_CHUNK& GetESkinNameChunk();

	int		GetEDispNameChunkSize();
	void	SetEDispNameChunkSize(int size);
	PMD_EDISP_NAME_CHUNK& GetEDispNameChunk();

	int		GetToonTexNameChunkSize();
	void	SetToonTexNameChunkSize(int size);
	PMD_TOONTEX_NAME_CHUNK& GetToonTexNameChunk();

	int		GetRigidBodyChunkSize();
	void	SetRigidBodyChunkSize(int size);
	PMD_RIGIDBODY_CHUNK& GetRigidBodyChunk();

	int		GetJointChunkSize();
	void	SetJointChunkSize(int size);
	PMD_JOINT_CHUNK& GetJointChunk();

public:
//	BoneNode* m_bone_node;
//	map<string,BoneNode*> m_bone_map;
//	vector<BoneNode*> m_bone_array;

	PMD_HEADER			m_header;
	PMD_VERTEX_CHUNK	m_vertexs;
	PMD_INDEX_CHUNK		m_indexs;
	PMD_MATERIAL_CHUNK	m_materials;
	PMD_BONE_CHUNK		m_bones;
	PMD_IK_CHUNK		m_ikbones;
	PMD_MORP_CHUNK		m_morps;
	PMD_CTRL_CHUNK		m_ctrls;
	PMD_GRP_NAME_CHUNK  m_grp_name;
	PMD_GRP_CHUNK		m_grp;
	
	PMD_EMODEL_NAME_RECORD	m_emodel_name;
	PMD_EBONE_NAME_CHUNK	m_ebone_name;
	PMD_ESKIN_NAME_CHUNK	m_eskin_name;
	PMD_EDISP_NAME_CHUNK	m_edisp_name;
	PMD_TOONTEX_NAME_CHUNK	m_toontex_name;
	PMD_RIGIDBODY_CHUNK		m_rigidbody;
	PMD_JOINT_CHUNK			m_joint;
};
